/*
*  Copyright:    Copyright (c) 2001 Global InfoTek, Inc.
*  Author:       Cynthia Cicalese
*  Date:         December, 2001
*  Company:      Global InfoTek, Inc.
*  Description:  Sensor database interface
*
********************************************************************************
* This code is the exclusive property of Global InfoTek Inc. and may not
* be used for any purpose without the written permission of Global
* InfoTek, Inc.
********************************************************************************
* Revision History
*/

package tutorial;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Vector;

public class SensorDB {

  private Connection connection;

  public SensorDB(String dbname) throws InitializationException,
    SQLException {

    try {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
    } catch (ClassNotFoundException e) {
      throw new InitializationException();
    }

    connection = DriverManager.getConnection("jdbc:odbc:" + dbname, "", "");
  }

  public void disconnect() throws SQLException {
    connection.close();
  }

  public void addSensor(String name, boolean active) throws SQLException {
    Statement stmt = connection.createStatement();
    String s;
    if (active)
      s = "INSERT INTO Sensors (Name, Active) VALUES (\'" + name + "\', Yes)";
    else
      s = "INSERT INTO Sensors (Name, Active) VALUES (\'" + name + "\', No)";
    stmt.executeUpdate(s);
  }

  public int removeSensor(String name) throws SQLException {
    Statement stmt = connection.createStatement();
    return stmt.executeUpdate(
      "DELETE FROM Sensors WHERE Name = \'" + name + "\'");
  }

  public int setActive(String name, boolean active) throws SQLException {
    Statement stmt = connection.createStatement();
    String s;
    if (active)
      s = "UPDATE Sensors SET Active = Yes WHERE Name = \'" + name + "\'";
    else
      s = "UPDATE Sensors SET Active = No WHERE Name = \'" + name + "\'";
    return stmt.executeUpdate(s);
  }

  public String[] getActiveSensors() throws SQLException {
    Statement stmt = connection.createStatement();
    ResultSet results = stmt.executeQuery(
      "SELECT Name FROM Sensors WHERE Active = Yes");
    Vector names = new Vector();
    while (results.next())
      names.addElement(results.getString("Name"));
    results.close();
    stmt.close();
    return (String[]) names.toArray(new String[0]);
  }

  public String[] getInactiveSensors() throws SQLException {
    Statement stmt = connection.createStatement();
    ResultSet results = stmt.executeQuery(
      "SELECT Name FROM Sensors WHERE Active = No");
    Vector names = new Vector();
    while (results.next())
      names.addElement(results.getString("Name"));
    results.close();
    stmt.close();
    return (String[]) names.toArray(new String[0]);
  }

  public Sensor[] getSensors() throws SQLException {
    Statement stmt = connection.createStatement();
    ResultSet results = stmt.executeQuery(
      "SELECT Name, Active FROM Sensors");
    Vector sensors = new Vector();
    while (results.next()) {
      String name = results.getString("Name");
      boolean active = results.getBoolean("Active");
      sensors.addElement(new Sensor(name, active));
    }
    results.close();
    stmt.close();
    return (Sensor[]) sensors.toArray(new Sensor[0]);
  }
}
